<script lang="ts" setup>
  import type { IMove, IPgn, IMoveColor } from '@/models/pgn/pgn.type'
import { faArrowRotateLeft } from '@fortawesome/free-solid-svg-icons';
import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome';
  const props = defineProps<{
    pgn: IPgn,
    moveNumber: number,
    moveColor: IMoveColor
  }>()

  const emit = defineEmits<{
    (event: 'clicked', moveNumber: number, color: IMoveColor): void
    (event: 'reset'): void
  }>()

  const isSelected = (move: IMove, color: IMoveColor) => 
    move.num === props.moveNumber && 
    color === props.moveColor 

</script>

<template>
  <div class="shadow-md rounded-md overflow-hidden ">
    <div class="grid grid-cols-[20%_40%_40%] sm:grid-cols-[3rem_6rem_6rem] gap-6 px-4 p-2 outline outline-1 outline-primary bg-primary">
      <UiButton class="flex justify-center items-center" @clicked="emit('reset')">
        <FontAwesomeIcon :icon="faArrowRotateLeft"></FontAwesomeIcon>
      </UiButton>
      <span class="text-center text-dark bg-light py-2">Blancs</span>
      <span class="text-center text-light bg-dark py-2">Noirs</span>
    </div>
    <div class="max-h-[500px] overflow-auto overflow-x-hidden flex flex-col mt-[1px] gap-[1px]">
      <div class="grid grid-cols-[20%_40%_40%] sm:grid-cols-[3rem_6rem_6rem] bg-contrast  bg-opacity-30 gap-6 px-4 items-center" 
        v-for="move in pgn" :key="move.num"
      >
        <span class="text-center text-xs">{{ move.num }}</span>
        <button
          class="text-center cursor-pointer transition-all" 
          :class="[isSelected(move, 'white') && 'rounded-xl bg-primary text-light']"
          @click="emit('clicked', move.num, 'white')">
        {{ move.white }}</button>
        <button
          class="text-center cursor-pointer transition-all" 
          :class="[isSelected(move, 'black') && 'rounded-xl bg-primary text-light']"
          @click="emit('clicked', move.num, 'black')"
        >{{ move.black }}</button>
      </div>
    </div>
  </div>
</template>
